{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

Code template generated with SynGen.
The original code is: lbHC11Syn.pas, released 2002-12-29.
Description: Syntax Parser/Highlighter
The initial author of this file is Eric Engler.
Copyright (c) 2002, all rights reserved.

Contributors to the SynEdit and mwEdit projects are listed in the
Contributors.txt file.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: $

You may retrieve the latest version of this file at the SynEdit home page,
located at http://SynEdit.SourceForge.net

-------------------------------------------------------------------------------}

unit SynHighlighterHC11;

{$I SynEdit.inc}

interface

uses
  SysUtils,
  Classes,
{$IFDEF SYN_CLX}
  QControls,
  QGraphics,
{$ELSE}
  Windows,
  Controls,
  Graphics,
{$ENDIF}
  SynEditTypes,
  SynEditHighlighter;

type
  TtkTokenKind = (
    tkComment,
    tkDirective,
    tkIdentifier,
    tkKey,
    tkNull,
    tkNumber,
    tkSpace,
    tkString,
    tkSymbol,
    tkUnknown);

  TkwKeyWordType = (kwNone, kwOperand, kwOperandOver, kwNoOperand);

  TRangeState = (rsUnKnown);

  TProcTableProc = procedure of object;

  // EWE: under this version of the highlighter, we are storing a table of
  // function pointers.
  PIdentFuncTableFunc = ^TIdentFuncTableFunc;
  TIdentFuncTableFunc = function: TtkTokenKind of object;

const
  MaxKey = 74;   // the number of functions we have

type
  TSynHC11Syn = class(TSynCustomHighlighter)
  private
    fLine: PChar;
    fLineNumber: Integer;
    fProcTable: array[#0..#255] of TProcTableProc;
    fRange: TRangeState;
    Run: LongInt;
    fStringLen: Integer;
    fToIdent: PChar;
    fTokenPos: Integer;
    fTokenID: TtkTokenKind;
    FKeyWordType: TkwKeyWordType;
    fIdentFuncTable: array[0..MaxKey] of TIdentFuncTableFunc;
    fCommentAttri: TSynHighlighterAttributes;
    fDirectiveAttri: TSynHighlighterAttributes;
    fIdentifierAttri: TSynHighlighterAttributes;
    fKeyAttri: TSynHighlighterAttributes;
    fNumberAttri: TSynHighlighterAttributes;
    fSpaceAttri: TSynHighlighterAttributes;
    fStringAttri: TSynHighlighterAttributes;
    fSymbolAttri: TSynHighlighterAttributes;
    function KeyHash(ToHash: PChar): Integer;
    function KeyComp(const aKey: string): Boolean;
    function Func4: TtkTokenKind;
    function Func6: TtkTokenKind;
    function Func8: TtkTokenKind;
    function Func9: TtkTokenKind;
    function Func10: TtkTokenKind;
    function Func11: TtkTokenKind;
    function Func12: TtkTokenKind;
    function Func13: TtkTokenKind;
    function Func14: TtkTokenKind;
    function Func18: TtkTokenKind;
    function Func19: TtkTokenKind;
    function Func20: TtkTokenKind;
    function Func21: TtkTokenKind;
    function Func22: TtkTokenKind;
    function Func23: TtkTokenKind;
    function Func24: TtkTokenKind;
    function Func25: TtkTokenKind;
    function Func26: TtkTokenKind;
    function Func27: TtkTokenKind;
    function Func28: TtkTokenKind;
    function Func29: TtkTokenKind;
    function Func30: TtkTokenKind;
    function Func31: TtkTokenKind;
    function Func32: TtkTokenKind;
    function Func33: TtkTokenKind;
    function Func34: TtkTokenKind;
    function Func35: TtkTokenKind;
    function Func36: TtkTokenKind;
    function Func37: TtkTokenKind;
    function Func38: TtkTokenKind;
    function Func39: TtkTokenKind;
    function Func40: TtkTokenKind;
    function Func41: TtkTokenKind;
    function Func42: TtkTokenKind;
    function Func43: TtkTokenKind;
    function Func44: TtkTokenKind;
    function Func45: TtkTokenKind;
    function Func46: TtkTokenKind;
    function Func47: TtkTokenKind;
    function Func48: TtkTokenKind;
    function Func49: TtkTokenKind;
    function Func50: TtkTokenKind;
    function Func51: TtkTokenKind;
    function Func52: TtkTokenKind;
    function Func53: TtkTokenKind;
    function Func54: TtkTokenKind;
    function Func55: TtkTokenKind;
    function Func56: TtkTokenKind;
    function Func57: TtkTokenKind;
    function Func58: TtkTokenKind;
    function Func59: TtkTokenKind;
    function Func60: TtkTokenKind;
    function Func61: TtkTokenKind;
    function Func63: TtkTokenKind;
    function Func64: TtkTokenKind;
    function Func67: TtkTokenKind;
    function Func68: TtkTokenKind;
    function Func70: TtkTokenKind;
    function Func73: TtkTokenKind;
    function Func74: TtkTokenKind;
    procedure AsciiCharProc;
    procedure CRProc;
    procedure DollarProc;
    procedure IdentProc;
    procedure LFProc;
    procedure NullProc;
    procedure NumberProc;
    procedure PercentProc;
    procedure SpaceProc;
    procedure StarProc;
    procedure StringProc;
    procedure SymbolProc;
    procedure UnknownProc;
    procedure CommentProc;
    function AltFunc: TtkTokenKind;
    procedure InitIdent;
    function IdentKind(MayBe: PChar): TtkTokenKind;
    procedure MakeMethodTables;
  protected
    function GetIdentChars: TSynIdentChars; override;
    function GetSampleSource: string; override;
    function IsFilterStored: Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
{$IFNDEF SYN_CPPB_1}class{$ENDIF}
      function GetLanguageName: string; override;
      function GetRange: Pointer; override;
      procedure ResetRange; override;
      procedure SetRange(Value: Pointer); override;
      function GetDefaultAttribute(Index: integer): TSynHighlighterAttributes; override;
      function GetEol: Boolean; override;
      function GetKeyWords: string;
      function GetTokenID: TtkTokenKind;
      procedure SetLine(NewValue: string; LineNumber: Integer); override;
      function GetToken: string; override;
      function GetTokenAttribute: TSynHighlighterAttributes; override;
      function GetTokenKind: integer; override;
      function GetTokenPos: Integer; override;
      procedure Next; override;
    published
      property CommentAttri: TSynHighlighterAttributes read fCommentAttri write fCommentAttri;
      property DirectiveAttri: TSynHighlighterAttributes read fDirectiveAttri write fDirectiveAttri;
      property IdentifierAttri: TSynHighlighterAttributes read fIdentifierAttri write fIdentifierAttri;
      property KeyAttri: TSynHighlighterAttributes read fKeyAttri write fKeyAttri;
      property NumberAttri: TSynHighlighterAttributes read fNumberAttri write fNumberAttri;
      property SpaceAttri: TSynHighlighterAttributes read fSpaceAttri write fSpaceAttri;
      property StringAttri: TSynHighlighterAttributes read fStringAttri write fStringAttri;
      property SymbolAttri: TSynHighlighterAttributes read fSymbolAttri write fSymbolAttri;
    end;

implementation

uses
  SynEditStrConst;

{$IFDEF SYN_COMPILER_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}
  SYNS_FilterHC11Assembler = '6811/6812 Assembler Files (*.asm,*.s,*.h, .lst)|*.ASM;*.S;*.H;*.lst';
  SYNS_LangHC11Assembler = '6811/6812 Assembler';

var
  Identifiers: array[#0..#255] of ByteBool;
  mHashTable: array[#0..#255] of Integer;

procedure MakeIdentTable;
var
  I, J: Char;
begin
  for I := #0 to #255 do
  begin
    case I of
      '_', 'a'..'z', 'A'..'Z': Identifiers[I] := True;
    else
      Identifiers[I] := False;
    end;
    J := UpCase(I);
    case I in ['_', 'A'..'Z', 'a'..'z'] of
      True: mHashTable[I] := Ord(J) - 64
    else
      mHashTable[I] := 0;
    end;
  end;
end;

procedure TSynHC11Syn.InitIdent;
var
  I: Integer;
  pF: PIdentFuncTableFunc;
begin
  pF := PIdentFuncTableFunc(@fIdentFuncTable);
  for I := Low(fIdentFuncTable) to High(fIdentFuncTable) do
  begin
    pF^ := AltFunc;
    Inc(pF);
  end;
  fIdentFuncTable[4] := Func4;
  fIdentFuncTable[6] := Func6;
  fIdentFuncTable[8] := Func8;
  fIdentFuncTable[9] := Func9;
  fIdentFuncTable[10] := Func10;
  fIdentFuncTable[11] := Func11;
  fIdentFuncTable[12] := Func12;
  fIdentFuncTable[13] := Func13;
  fIdentFuncTable[14] := Func14;
  fIdentFuncTable[18] := Func18;
  fIdentFuncTable[19] := Func19;
  fIdentFuncTable[20] := Func20;
  fIdentFuncTable[21] := Func21;
  fIdentFuncTable[22] := Func22;
  fIdentFuncTable[23] := Func23;
  fIdentFuncTable[24] := Func24;
  fIdentFuncTable[25] := Func25;
  fIdentFuncTable[26] := Func26;
  fIdentFuncTable[27] := Func27;
  fIdentFuncTable[28] := Func28;
  fIdentFuncTable[29] := Func29;
  fIdentFuncTable[30] := Func30;
  fIdentFuncTable[31] := Func31;
  fIdentFuncTable[32] := Func32;
  fIdentFuncTable[33] := Func33;
  fIdentFuncTable[34] := Func34;
  fIdentFuncTable[35] := Func35;
  fIdentFuncTable[36] := Func36;
  fIdentFuncTable[37] := Func37;
  fIdentFuncTable[38] := Func38;
  fIdentFuncTable[39] := Func39;
  fIdentFuncTable[40] := Func40;
  fIdentFuncTable[41] := Func41;
  fIdentFuncTable[42] := Func42;
  fIdentFuncTable[43] := Func43;
  fIdentFuncTable[44] := Func44;
  fIdentFuncTable[45] := Func45;
  fIdentFuncTable[46] := Func46;
  fIdentFuncTable[47] := Func47;
  fIdentFuncTable[48] := Func48;
  fIdentFuncTable[49] := Func49;
  fIdentFuncTable[50] := Func50;
  fIdentFuncTable[51] := Func51;
  fIdentFuncTable[52] := Func52;
  fIdentFuncTable[53] := Func53;
  fIdentFuncTable[54] := Func54;
  fIdentFuncTable[55] := Func55;
  fIdentFuncTable[56] := Func56;
  fIdentFuncTable[57] := Func57;
  fIdentFuncTable[58] := Func58;
  fIdentFuncTable[59] := Func59;
  fIdentFuncTable[60] := Func60;
  fIdentFuncTable[61] := Func61;
  fIdentFuncTable[63] := Func63;
  fIdentFuncTable[64] := Func64;
  fIdentFuncTable[67] := Func67;
  fIdentFuncTable[68] := Func68;
  fIdentFuncTable[70] := Func70;
  fIdentFuncTable[73] := Func73;
  fIdentFuncTable[74] := Func74;
end;

function TSynHC11Syn.KeyHash(ToHash: PChar): Integer;
begin
  Result := 0;
  while ToHash^ in ['_', 'a'..'z', 'A'..'Z'] do
  begin
    inc(Result, mHashTable[ToHash^]);
    inc(ToHash);
  end;
  fStringLen := ToHash - fToIdent;
end;

function TSynHC11Syn.KeyComp(const aKey: string): Boolean;
var
  I: Integer;
  Temp: PChar;
begin
  Temp := fToIdent;
  if Length(aKey) = fStringLen then
  begin
    Result := True;
    for i := 1 to fStringLen do
    begin
      if mHashTable[Temp^] <> mHashTable[aKey[i]] then
      begin
        Result := False;
        break;
      end;
      inc(Temp);
    end;
  end
  else
    Result := False;
end;

function TSynHC11Syn.Func4: TtkTokenKind;
begin
  if KeyComp('ABA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func6: TtkTokenKind;
begin
  if KeyComp('DB') then Result := tkKey else
    if KeyComp('DAA') then Result := tkKey else
      if KeyComp('CBA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func8: TtkTokenKind;
begin
  if KeyComp('BCC') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func9: TtkTokenKind;
begin
  if KeyComp('DC.B') then Result := tkKey else
    if KeyComp('ADCA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func10: TtkTokenKind;
begin
  if KeyComp('ADDA') then Result := tkKey else
    if KeyComp('ADCB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func11: TtkTokenKind;
begin
  if KeyComp('FCB') then Result := tkKey else
    if KeyComp('ADDB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func12: TtkTokenKind;
begin
  if KeyComp('DEC') then Result := tkKey else
    if KeyComp('FDB') then Result := tkKey else
      if KeyComp('FCC') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func13: TtkTokenKind;
begin
  if KeyComp('ADDD') then Result := tkKey else
    if KeyComp('DECA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func14: TtkTokenKind;
begin
  if KeyComp('BGE') then Result := tkKey else
    if KeyComp('DECB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func18: TtkTokenKind;
begin
  if KeyComp('LDAA') then Result := tkKey else
    if KeyComp('CLC') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func19: TtkTokenKind;
begin
  if KeyComp('BHI') then Result := tkKey else
    if KeyComp('LDAB') then Result := tkKey else
      if KeyComp('BLE') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func20: TtkTokenKind;
begin
  if KeyComp('LBCC') then Result := tkKey else
    if KeyComp('ANDA') then Result := tkKey else
      if KeyComp('LDD') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func21: TtkTokenKind;
begin
  if KeyComp('BNE') then Result := tkKey else
    if KeyComp('ANDB') then Result := tkKey else
      if KeyComp('BRA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func22: TtkTokenKind;
begin
  if KeyComp('SBA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func23: TtkTokenKind;
begin
  if KeyComp('TBA') then Result := tkKey else
    if KeyComp('TAB') then Result := tkKey else
      if KeyComp('CPD') then Result := tkKey else
        if KeyComp('DS') then Result := tkKey else
          if KeyComp('END') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func24: TtkTokenKind;
begin
  if KeyComp('PAG') then Result := tkKey else
    if KeyComp('BEQ') then Result := tkKey else
      if KeyComp('CLI') then Result := tkKey else
        if KeyComp('BCS') then Result := tkKey else
          if KeyComp('BMI') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func25: TtkTokenKind;
begin
  if KeyComp('ANDCC') then Result := tkKey else
    if KeyComp('DS.B') then Result := tkKey else
      if KeyComp('SBCA') then Result := tkKey else
        if KeyComp('DBNE') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func26: TtkTokenKind;
begin
  if KeyComp('SBCB') then Result := tkKey else
    if KeyComp('INC') then Result := tkKey else
      if KeyComp('NEG') then Result := tkKey else
        if KeyComp('LBGE') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func27: TtkTokenKind;
begin
  if KeyComp('ABX') then Result := tkKey else
    if KeyComp('INCA') then Result := tkKey else
      if KeyComp('SEC') then Result := tkKey else
        if KeyComp('BGND') then Result := tkKey else
          if KeyComp('NEGA') then Result := tkKey else
            if KeyComp('BVC') then Result := tkKey else
              if KeyComp('DW') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func28: TtkTokenKind;
begin
  if KeyComp('DBEQ') then Result := tkKey else
    if KeyComp('INCB') then Result := tkKey else
      if KeyComp('DES') then Result := tkKey else
        if KeyComp('CALL') then Result := tkKey else
          if KeyComp('NAM') then Result := tkKey else
            if KeyComp('NEGB') then Result := tkKey else
              if KeyComp('ABY') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func29: TtkTokenKind;
begin
  if KeyComp('BGT') then Result := tkKey else
    if KeyComp('BHS') then Result := tkKey else
      if KeyComp('PAGE') then Result := tkKey else
        if KeyComp('BLO') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func30: TtkTokenKind;
begin
  if KeyComp('DC.W') then Result := tkKey else
    if KeyComp('BPL') then Result := tkKey else
      if KeyComp('LOC') then Result := tkKey else
        if KeyComp('#IFDEF') then Result := tkKey else
          if KeyComp('IBNE') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func31: TtkTokenKind;
begin
  if KeyComp('LBLE') then Result := tkKey else
    if KeyComp('LBHI') then Result := tkKey else
      if KeyComp('COM') then Result := tkKey else
        if KeyComp('MEM') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func32: TtkTokenKind;
begin
  if KeyComp('COMA') then Result := tkKey else
    if KeyComp('BITA') then Result := tkKey else
      if KeyComp('ASL') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func33: TtkTokenKind;
begin
  if KeyComp('SEI') then Result := tkKey else
    if KeyComp('LBNE') then Result := tkKey else
      if KeyComp('LBRA') then Result := tkKey else
        if KeyComp('IBEQ') then Result := tkKey else
          if KeyComp('COMB') then Result := tkKey else
            if KeyComp('DEX') then Result := tkKey else
              if KeyComp('CMPA') then Result := tkKey else
                if KeyComp('BLS') then Result := tkKey else
                  if KeyComp('BITB') then Result := tkKey else
                    if KeyComp('CLR') then Result := tkKey else
                      if KeyComp('ASLA') then Result := tkKey else
                        if KeyComp('NAME') then Result := tkKey else
                          if KeyComp('WAI') then Result := tkKey else
                            if KeyComp('RMB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func34: TtkTokenKind;
begin
  if KeyComp('CLRA') then Result := tkKey else
    if KeyComp('BRN') then Result := tkKey else
      if KeyComp('BLT') then Result := tkKey else
        if KeyComp('ASLB') then Result := tkKey else
          if KeyComp('TBL') then Result := tkKey else
            if KeyComp('CMPB') then Result := tkKey else
              if KeyComp('DEY') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func35: TtkTokenKind;
begin
  if KeyComp('BCLR') then Result := tkKey else
    if KeyComp('LDS') then Result := tkKey else
      if KeyComp('CLRB') then Result := tkKey else
        if KeyComp('ORAA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func36: TtkTokenKind;
begin
  if KeyComp('ASLD') then Result := tkKey else
    if KeyComp('LBMI') then Result := tkKey else
      if KeyComp('LBCS') then Result := tkKey else
        if KeyComp('ORAB') then Result := tkKey else
          if KeyComp('EXG') then Result := tkKey else
            if KeyComp('LBEQ') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func37: TtkTokenKind;
begin
  if KeyComp('TAP') then Result := tkKey else
    if KeyComp('MINA') then Result := tkKey else
      if KeyComp('TPA') then Result := tkKey else
        if KeyComp('LEAS') then Result := tkKey else
          if KeyComp('#IFEQ') then Result := tkKey else
            if KeyComp('CLV') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func38: TtkTokenKind;
begin
  if KeyComp('CPS') then Result := tkKey else
    if KeyComp('SPC') then Result := tkKey else
      if KeyComp('REDEF') then Result := tkKey else
        if KeyComp('ASR') then Result := tkKey else
          if KeyComp('#ENDIF') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func39: TtkTokenKind;
begin
  if KeyComp('MAXA') then Result := tkKey else
    if KeyComp('LBVC') then Result := tkKey else
      if KeyComp('FILL') then Result := tkKey else
        if KeyComp('BSR') then Result := tkKey else
          if KeyComp('ETBL') then Result := tkKey else
            if KeyComp('JMP') then Result := tkKey else
              if KeyComp('ASRA') then Result := tkKey else
                if KeyComp('EORA') then Result := tkKey else
                  if KeyComp('ORCC') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func40: TtkTokenKind;
begin
  if KeyComp('EORB') then Result := tkKey else
    if KeyComp('EDIV') then Result := tkKey else
      if KeyComp('LDX') then Result := tkKey else
        if KeyComp('ASRB') then Result := tkKey else
          if KeyComp('ORG') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func41: TtkTokenKind;
begin
  if KeyComp('LBGT') then Result := tkKey else
    if KeyComp('LBHS') then Result := tkKey else
      if KeyComp('STAA') then Result := tkKey else
        if KeyComp('#ELSE') then Result := tkKey else
          if KeyComp('FDIV') then Result := tkKey else
            if KeyComp('LBLO') then Result := tkKey else
              if KeyComp('TBNE') then Result := tkKey else
                if KeyComp('EMACS') then Result := tkKey else
                  if KeyComp('RTC') then Result := tkKey else
                    if KeyComp('LDY') then Result := tkKey else
                      if KeyComp('ZMB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func42: TtkTokenKind;
begin
  if KeyComp('STAB') then Result := tkKey else
    if KeyComp('INS') then Result := tkKey else
      if KeyComp('LBPL') then Result := tkKey else
        if KeyComp('LEAX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func43: TtkTokenKind;
begin
  if KeyComp('#DEFINE') then Result := tkKey else
    if KeyComp('LEAY') then Result := tkKey else
      if KeyComp('STD') then Result := tkKey else
        if KeyComp('LSL') then Result := tkKey else
          if KeyComp('BVS') then Result := tkKey else
            if KeyComp('SUBA') then Result := tkKey else
              if KeyComp('EQU') then Result := tkKey else
                if KeyComp('CPX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func44: TtkTokenKind;
begin
  if KeyComp('TFR') then Result := tkKey else
    if KeyComp('IDIV') then Result := tkKey else
      if KeyComp('PSHA') then Result := tkKey else
        if KeyComp('SUBB') then Result := tkKey else
          if KeyComp('CPY') then Result := tkKey else
            if KeyComp('TBEQ') then Result := tkKey else
              if KeyComp('LSLA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func45: TtkTokenKind;
begin
  if KeyComp('REV') then Result := tkKey else
    if KeyComp('ROL') then Result := tkKey else
      if KeyComp('NOP') then Result := tkKey else
        if KeyComp('LBLS') then Result := tkKey else
          if KeyComp('PSHB') then Result := tkKey else
            if KeyComp('EMIND') then Result := tkKey else
              if KeyComp('LSLB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func46: TtkTokenKind;
begin
  if KeyComp('BSET') then Result := tkKey else
    if KeyComp('MUL') then Result := tkKey else
      if KeyComp('WAV') then Result := tkKey else
        if KeyComp('LBLT') then Result := tkKey else
          if KeyComp('SUBD') then Result := tkKey else
            if KeyComp('LBRN') then Result := tkKey else
              if KeyComp('ROLA') then Result := tkKey else
                if KeyComp('DS.W') then Result := tkKey else
                  if KeyComp('PSHC') then Result := tkKey else
                    if KeyComp('SEV') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func47: TtkTokenKind;
begin
  if KeyComp('PSHD') then Result := tkKey else
    if KeyComp('EMAXD') then Result := tkKey else
      if KeyComp('JSR') then Result := tkKey else
        if KeyComp('INX') then Result := tkKey else
          if KeyComp('LSLD') then Result := tkKey else
            if KeyComp('RTI') then Result := tkKey else
              if KeyComp('ROLB') then Result := tkKey else
                if KeyComp('BSZ') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func48: TtkTokenKind;
begin
  if KeyComp('INY') then Result := tkKey else
    if KeyComp('SEX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func49: TtkTokenKind;
begin
  if KeyComp('LSR') then Result := tkKey else
    if KeyComp('MINM') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func50: TtkTokenKind;
begin
  if KeyComp('LSRA') then Result := tkKey else
    if KeyComp('PULA') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func51: TtkTokenKind;
begin
  if KeyComp('OPT') then Result := tkKey else
    if KeyComp('LSRB') then Result := tkKey else
      if KeyComp('MAXM') then Result := tkKey else
        if KeyComp('#IFNEQ') then Result := tkKey else
          if KeyComp('ROR') then Result := tkKey else
            if KeyComp('EMUL') then Result := tkKey else
              if KeyComp('SWI') then Result := tkKey else
                if KeyComp('PULB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func52: TtkTokenKind;
begin
  if KeyComp('RORA') then Result := tkKey else
    if KeyComp('MOVB') then Result := tkKey else
      if KeyComp('TTL') then Result := tkKey else
        if KeyComp('PULC') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func53: TtkTokenKind;
begin
  if KeyComp('PULD') then Result := tkKey else
    if KeyComp('RORB') then Result := tkKey else
      if KeyComp('LSRD') then Result := tkKey else
        if KeyComp('BRCLR') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func54: TtkTokenKind;
begin
  if KeyComp('RMW') then Result := tkKey else
    if KeyComp('EMINM') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func55: TtkTokenKind;
begin
  if KeyComp('TRAP') then Result := tkKey else
    if KeyComp('LBVS') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func56: TtkTokenKind;
begin
  if KeyComp('EMAXM') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func57: TtkTokenKind;
begin
  if KeyComp('RTS') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func58: TtkTokenKind;
begin
  if KeyComp('STS') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func59: TtkTokenKind;
begin
  if KeyComp('EDIVS') then Result := tkKey else
    if KeyComp('TST') then Result := tkKey else
      if KeyComp('XGDX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func60: TtkTokenKind;
begin
  if KeyComp('TSTA') then Result := tkKey else
    if KeyComp('XGDY') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func61: TtkTokenKind;
begin
  if KeyComp('TSTB') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func63: TtkTokenKind;
begin
  if KeyComp('IDIVS') then Result := tkKey else
    if KeyComp('TXS') then Result := tkKey else
      if KeyComp('TSX') then Result := tkKey else
        if KeyComp('STX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func64: TtkTokenKind;
begin
  if KeyComp('STY') then Result := tkKey else
    if KeyComp('TYS') then Result := tkKey else
      if KeyComp('BRSET') then Result := tkKey else
        if KeyComp('TSY') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func67: TtkTokenKind;
begin
  if KeyComp('PSHX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func68: TtkTokenKind;
begin
  if KeyComp('PSHY') then Result := tkKey else
    if KeyComp('#INCLUDE') then Result := tkKey else
      if KeyComp('REVW') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func70: TtkTokenKind;
begin
  if KeyComp('#IFPART') then Result := tkKey else
    if KeyComp('STOP') then Result := tkKey else
      if KeyComp('EMULS') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func73: TtkTokenKind;
begin
  if KeyComp('MOVW') then Result := tkKey else
    if KeyComp('PULX') then Result := tkKey else Result := tkIdentifier;
end;

function TSynHC11Syn.Func74: TtkTokenKind;
begin
  if KeyComp('PULY') then Result := tkKey else Result := tkIdentifier;
end;


function TSynHC11Syn.AltFunc: TtkTokenKind;
begin
  Result := tkIdentifier;
end;

function TSynHC11Syn.IdentKind(MayBe: PChar): TtkTokenKind;
var
  HashKey: Integer;
begin
  fToIdent := MayBe;
  HashKey := KeyHash(MayBe);

  if HashKey <= MaxKey then
  begin
    Result := fIdentFuncTable[HashKey];
  end
  else
  begin
    Result := tkIdentifier;
  end;
end;

procedure TSynHC11Syn.MakeMethodTables;
var
  I: Char;
begin
  for I := #0 to #255 do
    case I of
      #0: fProcTable[I] := NullProc;
      #10: fProcTable[I] := LFProc;
      #13: fProcTable[I] := CRProc;
      #1..#9, #11, #12, #14..#32: fProcTable[I] := SpaceProc;
      #34: fProcTable[I] := StringProc;
      #39: fProcTable[I] := AsciiCharProc;
      '$': fProcTable[I] := DollarProc;
      'A'..'Z', 'a'..'z', '_': fProcTable[I] := IdentProc;
      '0'..'9': fProcTable[I] := NumberProc;
      '%': fProcTable[I] := PercentProc;
      '*': fProcTable[I] := StarProc;
      ';': fProcTable[I] := CommentProc;
      '#', ':', ',', '(', ')': fProcTable[I] := SymbolProc;
    else
      fProcTable[I] := UnknownProc;
    end;
end;

procedure TSynHC11Syn.SpaceProc;
begin
  inc(Run);
  if FKeyWordType in [kwOperandOver, kwNoOperand] then
  begin
    FKeyWordType := kwNone;
    fTokenID := tkComment;
    while not (fLine[Run] in [#0, #10, #13]) do
      Inc(Run);
  end
  else
  begin
    if FKeyWordType = kwOperand then
      FKeyWordType := kwOperandOver;
    fTokenID := tkSpace;
    while (fLine[Run] <= #32) and not (fLine[Run] in [#0, #10, #13]) do
      inc(Run);
  end;
end;

procedure TSynHC11Syn.NullProc;
begin
  fTokenID := tkNull;
end;

procedure TSynHC11Syn.CRProc;
begin
  fTokenID := tkSpace;
  FKeyWordType := kwNone;
  inc(Run);
  if fLine[Run] = #10 then
    inc(Run);
end;

procedure TSynHC11Syn.LFProc;
begin
  FKeyWordType := kwNone;
  fTokenID := tkSpace;
  inc(Run);
end;

constructor TSynHC11Syn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fCommentAttri := TSynHighLighterAttributes.Create(SYNS_AttrComment);
  fCommentAttri.Style := [fsItalic];
  fCommentAttri.Foreground := clNavy;
  AddAttribute(fCommentAttri);

  fDirectiveAttri := TSynHighLighterAttributes.Create(SYNS_AttrDirective);
  AddAttribute(fDirectiveAttri);

  fIdentifierAttri := TSynHighLighterAttributes.Create(SYNS_AttrIdentifier);
  AddAttribute(fIdentifierAttri);

  fKeyAttri := TSynHighLighterAttributes.Create(SYNS_AttrReservedWord);
  fKeyAttri.Style := [fsBold];
  AddAttribute(fKeyAttri);

  fNumberAttri := TSynHighLighterAttributes.Create(SYNS_AttrNumber);
  AddAttribute(fNumberAttri);

  fSpaceAttri := TSynHighLighterAttributes.Create(SYNS_AttrSpace);
  AddAttribute(fSpaceAttri);

  fStringAttri := TSynHighLighterAttributes.Create(SYNS_AttrString);
  AddAttribute(fStringAttri);

  fSymbolAttri := TSynHighLighterAttributes.Create(SYNS_AttrSymbol);
  AddAttribute(fSymbolAttri);

  SetAttributesOnChange(DefHighlightChange);
  InitIdent;
  MakeMethodTables;
  fDefaultFilter := SYNS_FilterHC11Assembler;
  fRange := rsUnknown;
end;

procedure TSynHC11Syn.SetLine(NewValue: string; LineNumber: Integer);
begin
  fLine := PChar(NewValue);
  Run := 0;
  fLineNumber := LineNumber;
  Next;
end;

procedure TSynHC11Syn.AsciiCharProc;
begin
  fTokenID := tkString;
  if (FLine[Run + 1] = #39) and (FLine[Run + 2] = #39) then
    inc(Run, 2);
  repeat
    case FLine[Run] of
      #0, #10, #13:
        begin
          FKeyWordType := kwNone;
          break;
        end;
    end;
    inc(Run);
  until FLine[Run] = #39;
  if FLine[Run] <> #0 then
    inc(Run);
end;

procedure TSynHC11Syn.DollarProc;
begin
  fTokenID := tkNumber;
  inc(Run);
  while FLine[Run] in ['0'..'9', 'A'..'F', 'a'..'f'] do
    inc(Run);
end;

procedure TSynHC11Syn.IdentProc;
begin
  fTokenID := IdentKind((fLine + Run));
  inc(Run, fStringLen);
  while Identifiers[fLine[Run]] do
    inc(Run);
end;

procedure TSynHC11Syn.NumberProc;
begin
  inc(Run);
  fTokenID := tkNumber;
  // Hex is handled in DollarProc!
  while FLine[Run] in ['0'..'9'] do
    inc(Run);
end;

procedure TSynHC11Syn.PercentProc;
begin
  inc(Run);
  fTokenID := tkNumber;
  while FLine[Run] in ['0'..'1'] do
    inc(Run);
end;

procedure TSynHC11Syn.StarProc;
begin
  inc(Run);
  if FKeyWordType = kwOperandOver then
    fTokenID := tkSymbol
  else
  begin
    fTokenID := tkComment;
    while not (fLine[Run] in [#0, #10, #13]) do
      inc(Run);
  end;
end;

procedure TSynHC11Syn.CommentProc;
begin
  fTokenID := tkComment;
  repeat
    Inc(Run);
  until fLine[Run] in [#0, #10, #13];
end;

procedure TSynHC11Syn.StringProc;
begin
  fTokenID := tkString;
  if (FLine[Run + 1] = #34) and (FLine[Run + 2] = #34) then
    inc(Run, 2);
  repeat
    case FLine[Run] of
      #0, #10, #13: break;
    end;
    inc(Run);
  until FLine[Run] = #34;
  if FLine[Run] <> #0 then
    inc(Run);
end;

procedure TSynHC11Syn.SymbolProc;
begin
  fTokenID := tkSymbol;
  inc(Run);
end;

procedure TSynHC11Syn.UnknownProc;
begin
{$IFDEF SYN_MBCSSUPPORT}
  if FLine[Run] in LeadBytes then
    Inc(Run, 2)
  else
{$ENDIF}
    inc(Run);
  fTokenID := tkUnknown;
end;

procedure TSynHC11Syn.Next;
begin
  fTokenPos := Run;
  fProcTable[fLine[Run]];
end;

function TSynHC11Syn.GetDefaultAttribute(Index: integer): TSynHighLighterAttributes;
begin
  case Index of
    SYN_ATTR_COMMENT: Result := fCommentAttri;
    SYN_ATTR_IDENTIFIER: Result := fIdentifierAttri;
    SYN_ATTR_KEYWORD: Result := fKeyAttri;
    SYN_ATTR_STRING: Result := fStringAttri;
    SYN_ATTR_WHITESPACE: Result := fSpaceAttri;
    SYN_ATTR_SYMBOL: Result := fSymbolAttri;
  else
    Result := nil;
  end;
end;

function TSynHC11Syn.GetEol: Boolean;
begin
  Result := fTokenID = tkNull;
end;

function TSynHC11Syn.GetKeyWords: string;
begin
  Result := 
    '#DEFINE,#ELSE,#ENDIF,#IFDEF,#IFEQ,#IFNEQ,#IFPART,#INCLUDE,ABA,ABX,ABY' +
    ',ADCA,ADCB,ADDA,ADDB,ADDD,ANDA,ANDB,ANDCC,ASL,ASLA,ASLB,ASLD,ASR,ASRA,' +
    'ASRB,BCC,BCLR,BCS,BEQ,BGE,BGND,BGT,BHI,BHS,BITA,BITB,BLE,BLO,BLS,BLT,B' +
    'MI,BNE,BPL,BRA,BRCLR,BRN,BRSET,BSET,BSR,BSZ,BVC,BVS,CALL,CBA,CLC,CLI,C' +
    'LR,CLRA,CLRB,CLV,CMPA,CMPB,COM,COMA,COMB,CPD,CPS,CPX,CPY,DAA,DB,DBEQ,D' +
    'BNE,DC.B,DC.W,DEC,DECA,DECB,DES,DEX,DEY,DS,DS.B,DS.W,DW,EDIV,EDIVS,EMA' +
    'CS,EMAXD,EMAXM,EMIND,EMINM,EMUL,EMULS,END,EORA,EORB,EQU,ETBL,EXG,FCB,F' +
    'CC,FDB,FDIV,FILL,IBEQ,IBNE,IDIV,IDIVS,INC,INCA,INCB,INS,INX,INY,JMP,JS' +
    'R,LBCC,LBCS,LBEQ,LBGE,LBGT,LBHI,LBHS,LBLE,LBLO,LBLS,LBLT,LBMI,LBNE,LBP' +
    'L,LBRA,LBRN,LBVC,LBVS,LDAA,LDAB,LDD,LDS,LDX,LDY,LEAS,LEAX,LEAY,LOC,LSL' +
    ',LSLA,LSLB,LSLD,LSR,LSRA,LSRB,LSRD,MAXA,MAXM,MEM,MINA,MINM,MOVB,MOVW,M' +
    'UL,NAM,NAME,NEG,NEGA,NEGB,NOP,OPT,ORAA,ORAB,ORCC,ORG,PAG,PAGE,PSHA,PSH' +
    'B,PSHC,PSHD,PSHX,PSHY,PULA,PULB,PULC,PULD,PULX,PULY,REDEF,REV,REVW,RMB' +
    ',RMW,ROL,ROLA,ROLB,ROR,RORA,RORB,RTC,RTI,RTS,SBA,SBCA,SBCB,SEC,SEI,SEV' +
    ',SEX,SPC,STAA,STAB,STD,STOP,STS,STX,STY,SUBA,SUBB,SUBD,SWI,TAB,TAP,TBA' +
    ',TBEQ,TBL,TBNE,TFR,TPA,TRAP,TST,TSTA,TSTB,TSX,TSY,TTL,TXS,TYS,WAI,WAV,' +
    'XGDX,XGDY,ZMB';
end;

function TSynHC11Syn.GetToken: string;
var
  Len: LongInt;
begin
  Len := Run - fTokenPos;
  SetString(Result, (FLine + fTokenPos), Len);
end;

function TSynHC11Syn.GetTokenID: TtkTokenKind;
begin
  Result := fTokenId;
end;

function TSynHC11Syn.GetTokenAttribute: TSynHighLighterAttributes;
begin
  case GetTokenID of
    tkComment: Result := fCommentAttri;
    tkDirective: Result := fDirectiveAttri;
    tkIdentifier: Result := fIdentifierAttri;
    tkKey: Result := fKeyAttri;
    tkNumber: Result := fNumberAttri;
    tkSpace: Result := fSpaceAttri;
    tkString: Result := fStringAttri;
    tkSymbol: Result := fSymbolAttri;
    tkUnknown: Result := fIdentifierAttri;
  else
    Result := nil;
  end;
end;

function TSynHC11Syn.GetTokenKind: integer;
begin
  Result := Ord(fTokenId);
end;

function TSynHC11Syn.GetTokenPos: Integer;
begin
  Result := fTokenPos;
end;

function TSynHC11Syn.GetIdentChars: TSynIdentChars;
begin
  Result := ['_', 'a'..'z', 'A'..'Z'];
end;

function TSynHC11Syn.GetSampleSource: string;
  begin
    Result :=
      '* TX.ASM Sample Source Code'#13#10 +
      'MAINORG EQU     $F800'#13#10 +
      '        ORG     $F800'#13#10 +
      'MAIN    EQU     *        ;Start assembling here'#13#10 +
      '        STAA    SCCR2'#13#10 +
      'loop:'#13#10 +
      '        LDAA    #$05'#13#10 +
      '	BRA	loop		;Do it again'#13#10 +
      '	ORG	$FFFE		;Reset vector interrupt setup'#13#10 +
      '	END';
  end;

function TSynHC11Syn.IsFilterStored: Boolean;
begin
  Result := fDefaultFilter <> SYNS_FilterHC11Assembler;
end;

{$IFNDEF SYN_CPPB_1}class{$ENDIF}
  function TSynHC11Syn.GetLanguageName: string;
  begin
    Result := SYNS_LangHC11Assembler;
  end;

  procedure TSynHC11Syn.ResetRange;
  begin
    fRange := rsUnknown;
  end;

  procedure TSynHC11Syn.SetRange(Value: Pointer);
  begin
    fRange := TRangeState(Value);
  end;

  function TSynHC11Syn.GetRange: Pointer;
  begin
    Result := Pointer(fRange);
  end;

initialization
  MakeIdentTable;
{$IFNDEF SYN_CPPB_1}
  RegisterPlaceableHighlighter(TSynHC11Syn);
{$ENDIF}
end.

